src/main/java/com/exabit/polariserp/tvmax/barrios/BarriosManBean.java
package com.exabit.polariserp.tvmax.barrios;

import com.exabit.polariserp.tvmax.entidades.Barrio;
import com.exabit.polariserp.tvmax.sesbeans.BarrioFacade;
import com.exabit.polariserp.tvmax.sesbeans.ZonaFacade;
import com.exabit.polariserp.tvmax.util.Paginador;
import com.google.gson.Gson;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.faces.view.ViewScoped;

/**
 *
 * @author cristhian-kn
 */
@Named(value = "barriosManBean")
@ViewScoped
public class BarriosManBean implements Serializable {

    private static final Logger LOG = Logger.getLogger(BarriosManBean.class.getName());

    //<editor-fold desc="EJBs" defaultstate="collapsed">
    @EJB
    private ZonaFacade zonaFacade;

    @EJB
    private BarrioFacade barrioFacade;
    //</editor-fold>

    //<editor-fold desc="Properties" defaultstate="collapsed">
    private List<Barrio> lstBarrios = new ArrayList<>();
    private String txtBusqueda="";
    private String seleccionBarriosIDJson;
    private String msg = "n";
    private Integer idZonaTmp;
    private Integer idBarrio;
    private String nombreBarrio;
    private String tipoMsg;
    private String cabeceraMsg;
    private String cuerpoMsg;
    private final Paginador<Barrio> paginador;

    public Paginador<Barrio> getPaginador() {
        return paginador;
    }
    
    //</editor-fold>

    //<editor-fold desc="Getters and Setters" defaultstate="collapsed">
    public String getCuerpoMsg() {
        return cuerpoMsg;
    }

    public void setCuerpoMsg(String cuerpoMsg) {
        this.cuerpoMsg = cuerpoMsg;
    }

    public String getCabeceraMsg() {
        return cabeceraMsg;
    }

    public void setCabeceraMsg(String cabeceraMsg) {
        this.cabeceraMsg = cabeceraMsg;
    }

    public String getTipoMsg() {
        return tipoMsg;
    }

    public void setTipoMsg(String tipoMsg) {
        this.tipoMsg = tipoMsg;
    }

    public String getNombreBarrio() {
        return nombreBarrio;
    }

    public void setNombreBarrio(String nombreBarrio) {
        this.nombreBarrio = nombreBarrio;
    }

    public Integer getIdBarrio() {
        return idBarrio;
    }

    public void setIdBarrio(Integer idBarrio) {
        this.idBarrio = idBarrio;
    }

    public List<Barrio> getLstBarrios() {
        return lstBarrios;
    }

    public void setLstBarrios(List<Barrio> lstBarrios) {
        this.lstBarrios = lstBarrios;
    }

    public String getTxtBusqueda() {
        return txtBusqueda;
    }

    public void setTxtBusqueda(String txtBusqueda) {
        this.txtBusqueda = txtBusqueda;
    }

    public String getSeleccionBarriosIDJson() {
        return seleccionBarriosIDJson;
    }

    public void setSeleccionBarriosIDJson(String seleccionBarriosIDJson) {
        this.seleccionBarriosIDJson = seleccionBarriosIDJson;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public Integer getIdZonaTmp() {
        return idZonaTmp;
    }

    public void setIdZonaTmp(Integer idZonaTmp) {
        this.idZonaTmp = idZonaTmp;
    }
    //</editor-fold>

    /**
     * Creates a new instance of BarriosManBean
     */
    public BarriosManBean() {
        this.paginador=new Paginador(this.lstBarrios);
    }

    @PostConstruct
    private void postConstruct() {
        this.paginador.agregarItemsLista(this.barrioFacade.findAll());
    }

    public void eliminarBarrios() {
        try {
            Gson gson = new Gson();
            Integer[] idsEliminar = gson.fromJson(this.seleccionBarriosIDJson, Integer[].class);
            for (Integer ide : idsEliminar) {
                System.out.println("eliminar: " + ide);
                this.barrioFacade.remove(this.barrioFacade.find(ide));
            }
            this.tipoMsg = "info";
            this.cabeceraMsg = "Éxito";
            this.cuerpoMsg = "Barrios eliminados correctamente";
            
        } catch (Exception ex) {
            LOG.log(Level.SEVERE, "Error al eliminar", ex);
            this.tipoMsg = "error";
            this.cabeceraMsg = "Error al eliminar";
            this.cuerpoMsg = ex.getMessage();
        }
        this.buscarBarrio();
    }

    public void buscarBarrio() {
        this.paginador.limpiarLista();
        if (this.txtBusqueda.isEmpty()) {
            this.paginador.agregarItemsLista(this.barrioFacade.findAll());
//            this.lstBarrios.addAll(this.barrioFacade.findAll());
        } else {
            this.paginador.agregarItemsLista(this.barrioFacade.buscarBarrio(this.txtBusqueda));
//            this.lstBarrios.addAll(this.barrioFacade.buscarBarrio(this.txtBusqueda));
        }
        System.out.println("Buscar: " + this.txtBusqueda);
    }

    public List<Barrio> getLstBarriosOrdenados() {
        return this.barrioFacade.getListaBarriosOrdenado();
    }

    public void cargarDatosBarrio() {
        System.out.println("Cargar datos bario");
        if (this.idBarrio != null) {
            Barrio b = this.barrioFacade.find(this.idBarrio);
            this.nombreBarrio = b.getNombre();
            this.idZonaTmp = b.getZona().getIdzona();
        }
    }

    public void guardarBarrio() {
        try {
            Barrio b = new Barrio();
            b.setIdbarrio(this.idBarrio);
            b.setNombre(this.nombreBarrio);
            b.setZona(this.zonaFacade.find(this.idZonaTmp));
            if (b.getIdbarrio() != null) {
                this.barrioFacade.edit(b);
            } else {
                this.barrioFacade.create(b);
            }
            this.tipoMsg = "info";
            this.cabeceraMsg = "Éxito";
            this.cuerpoMsg = "Barrio guardado correctamente.";
            
        } catch (Exception ex) {
            LOG.log(Level.SEVERE, "Error al guardar barrio", ex);
            this.tipoMsg = "error";
            this.cabeceraMsg = "Error al guardar";
        }
        this.buscarBarrio();
    }

    public void limpiar() {
        this.idBarrio = null;
        this.nombreBarrio = null;
        this.idZonaTmp = null;
    }
}

src/main/java/com/exabit/polariserp/tvmax/cliente/DetalleClienteManBean.java
package com.exabit.polariserp.tvmax.cliente;

import com.exabit.polariserp.tvmax.entidades.Cliente;
import com.exabit.polariserp.tvmax.entidades.Funcionario;
import com.exabit.polariserp.tvmax.entidades.Suscripcion;
import com.exabit.polariserp.tvmax.sesbeans.BarrioFacade;
import com.exabit.polariserp.tvmax.sesbeans.ClienteFacade;
import com.exabit.polariserp.tvmax.sesbeans.FuncionarioFacade;
import com.exabit.polariserp.tvmax.sesbeans.SuscripcionFacade;
import com.exabit.polariserp.tvmax.util.EntidadesEstaticas;
import java.io.Serializable;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.faces.view.ViewScoped;

/**
 *
 * @author traver
 */
@Named(value = "detalleClienteManBean")
@ViewScoped
public class DetalleClienteManBean implements Serializable {

    private static final Logger LOG = Logger.getLogger(DetalleClienteManBean.class.getName());

    @EJB
    private ClienteFacade clienteFacade;
    @EJB
    private SuscripcionFacade suscripcionFacade;
    @EJB
    private BarrioFacade barrioFacade;
    @EJB
    private FuncionarioFacade funcionarioFacade;

    private String cabeceraMsgCli;
    private String cuerpoMsgCli;
    private String nombreCli;
    private String razonSocialCli;
    private String apellidoCli;
    private String telefonoCli;
    private Integer dvrucCli;
    private Integer ciCli;
    private String direccionFacturacionCli;
    private Integer idBarrioFacturacionCli;
    private Integer idCobradorCli;
    private String tipoMsg = "info";

   //<editor-fold desc="Getters y Setters" defaultstate="collapsed">
    public String getTipoMsg() {
        return tipoMsg;
    }

    public void setTipoMsg(String tipoMsg) {
        this.tipoMsg = tipoMsg;
    }
    public Integer getIdCobradorCli() {
        return idCobradorCli;
    }

    public void setIdCobradorCli(Integer idCobradorCli) {
        this.idCobradorCli = idCobradorCli;
    }
    
    public Integer getIdBarrioFacturacionCli() {
        return idBarrioFacturacionCli;
    }

    public void setIdBarrioFacturacionCli(Integer idBarrioFacturacionCli) {
        this.idBarrioFacturacionCli = idBarrioFacturacionCli;
    }

    public String getDireccionFacturacionCli() {
        return direccionFacturacionCli;
    }

    public void setDireccionFacturacionCli(String direccionFacturacionCli) {
        this.direccionFacturacionCli = direccionFacturacionCli;
    }


    public Integer getCiCli() {
        return ciCli;
    }

    public void setCiCli(Integer ciCli) {
        this.ciCli = ciCli;
    }

    public Integer getDvrucCli() {
        return dvrucCli;
    }

    public void setDvrucCli(Integer dvrucCli) {
        this.dvrucCli = dvrucCli;
    }

    public String getNombreCli() {
        return nombreCli;
    }

    public void setNombreCli(String nombreCli) {
        this.nombreCli = nombreCli;
    }

    public String getApellidoCli() {
        return apellidoCli;
    }

    public void setApellidoCli(String apellidoCli) {
        this.apellidoCli = apellidoCli;
    }

    public String getRazonSocialCli() {
        return razonSocialCli;
    }

    public void setRazonSocialCli(String razonSocialCli) {
        this.razonSocialCli = razonSocialCli;
    }

    public String getTelefonoCli() {
        return telefonoCli;
    }

    public void setTelefonoCli(String telefonoCli) {
        this.telefonoCli = telefonoCli;
    }

    public String getCabeceraMsgCli() {
        return cabeceraMsgCli;
    }

    public void setCabeceraMsgCli(String cabeceraMsgCli) {
        this.cabeceraMsgCli = cabeceraMsgCli;
    }

    public String getCuerpoMsgCli() {
        return cuerpoMsgCli;
    }

    public void setCuerpoMsgCli(String cuerpoMsgCli) {
        this.cuerpoMsgCli = cuerpoMsgCli;
    }
    //</editor-fold>

    /**
     * Creates a new instance of DetalleClienteManBean
     */
    public DetalleClienteManBean() {
    }

    private Integer idcliente;

    public Integer getIdcliente() {
        return idcliente;
    }

    public void setIdcliente(Integer idcliente) {
        this.idcliente = idcliente;
    }

    public void cargarDatosCliente() {
        System.out.println("idcliente mem"+this.idcliente);
        if (this.idcliente != null) {
            Cliente c = this.clienteFacade.find(this.idcliente);
            this.nombreCli = c.getNombres();
            this.apellidoCli = c.getApellidos();
            this.razonSocialCli = c.getRazonSocial();
            this.telefonoCli = c.getTelefono1();
            this.ciCli = c.getCi();
            if (c.getDvRuc() != null) {
                this.dvrucCli = (int) c.getDvRuc();
            }
            this.direccionFacturacionCli=c.getDireccion();
            if(c.getBarrio()!=null){
                this.idBarrioFacturacionCli=c.getBarrio().getIdbarrio();
            }
            if(c.getCobrador()!=null){
                this.idCobradorCli=c.getCobrador().getIdfuncionario();
            }
        }else{
            this.limpiarCampos();
        }
    }

    public List<Suscripcion> getSuscripcionesCli() {
        if (this.idcliente != null) {
            Cliente c = this.clienteFacade.find(this.idcliente);
            if (c != null) {
                return this.suscripcionFacade.getSuscripciones(c);
            } else {
                return new LinkedList<>();
            }
        } else {
            return new LinkedList<>();
        }
    }

    public void guardarCliente() {
        try {
            System.out.println("Guardar cliente");
            Cliente cli;
            if (this.idcliente != null) {
                cli = this.clienteFacade.find(this.idcliente);
            } else {
                cli = new Cliente();
            }
            cli.setNombres(this.nombreCli);
            cli.setApellidos(this.apellidoCli);
            cli.setRazonSocial(this.razonSocialCli);
            cli.setCi(this.ciCli);
            System.out.println("idbarrio cli guardar: "+this.idBarrioFacturacionCli);
            cli.setDireccion(this.direccionFacturacionCli);
            cli.setCobrador(this.funcionarioFacade.find(this.idCobradorCli));
            cli.setBarrio(this.barrioFacade.find(this.idBarrioFacturacionCli));
            if (this.dvrucCli != null) {
                cli.setDvRuc(this.dvrucCli.shortValue());
            }
            cli.setTelefono1(this.telefonoCli);
            if (this.idcliente != null) {
                for(Suscripcion sus:cli.getSuscripcionList()){
                    sus.setCobrador(cli.getCobrador());
                    this.suscripcionFacade.edit(sus);
                }
                this.clienteFacade.edit(cli);
            }else{
                cli.setCategoria(EntidadesEstaticas.CATEGORIA_CLIENTE_SIN_CATEGORIA);
                this.clienteFacade.create(cli);
                this.idcliente=cli.getIdcliente();
                System.out.println("Id cliente generado: "+this.idcliente);
            }
            this.tipoMsg = "info";
            this.cabeceraMsgCli = "Exito";
            this.cuerpoMsgCli = "Guardado correctamente";
        } catch (Exception ex) {
            LOG.log(Level.SEVERE, "Error al guardar cliente", ex);
            this.tipoMsg = "error";
            this.cabeceraMsgCli = "Error";
            this.cuerpoMsgCli = "Algo salió mal: " + ex.getMessage();
        }
    }

    public void limpiarCampos() {
        this.idcliente = null;
        this.apellidoCli = null;
        this.dvrucCli = null;
        this.nombreCli = null;
        this.razonSocialCli = null;
        this.telefonoCli = null;
        this.ciCli = null;
        this.idBarrioFacturacionCli=null;
        this.direccionFacturacionCli=null;
        this.idCobradorCli=null;
    }
    
    public List<Funcionario> getLstCobradores(){
        return this.funcionarioFacade.getCobradoresActivos();
    }
    
    
}

src/main/webapp/cliente/detallecliente/formcliente.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html>
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                xmlns:f="http://xmlns.jcp.org/jsf/core"
                xmlns:jsf="http://xmlns.jcp.org/jsf">

    <div prependId="false" class="ui segments">
        <h:form prependId="false" class="ui segment">
            <div class="ui grid">
                <div jsf:id="tituloDetalleCliente" class="eight wide column">
                    <div  style="font-size: 18px; font-weight: bold">
                        <i class="user icon" />
                        Cliente
                    </div>
                    <div jsf:rendered="#{empty detalleClienteManBean.idcliente}" style="color: gray">
                        Nuevo cliente
                    </div>
                    <div jsf:rendered="#{not empty detalleClienteManBean.idcliente}" style="color: gray">
                        Código: <span id="idcliente">#{detalleClienteManBean.idcliente}</span>
                    </div>
                </div>

                <div class="eight wide right aligned column">
                    <h:commandLink style="#{empty detalleClienteManBean.idcliente?'display: none':''}" id="btnAgregarCliente" class="ui green icon button"  action="#{detalleClienteManBean.limpiarCampos()}" pt:data-tooltip="Nuevo cliente" pt:data-inverted="" pt:data-position="bottom center">
                        <i class="add icon" />
                        <f:ajax render="formCliente tituloDetalleCliente tblSuscripciones tblCuotasSusc tblOtrosServicios" execute="@form" onevent="function(data){ajaxNuevoCliente(data);}" />
                    </h:commandLink>
                </div>
            </div>
        </h:form>
        <div class="ui segment blue">
            <h:form id="formCliente" prependId="false" class="ui form">
                <div class="fields">
                    <div class="eight wide field">
                        <label>Apellidos</label>
                        <h:inputText id="txfApellidosCli" pt:placeholder="Perez" value="#{detalleClienteManBean.apellidoCli}"/>
                    </div>
                    <div class="eight wide field">
                        <label>Nombres</label>
                        <h:inputText id="txfNombresCli" pt:placeholder="Juan" value="#{detalleClienteManBean.nombreCli}" />
                    </div>
                </div>
                <div id="fldRazonsSocialCli" class="field required">
                    <label>Razón social</label>
                    <h:inputText id="txfRazonSocialCli" pt:placeholder="Juan Perez" value="#{detalleClienteManBean.razonSocialCli}" />
                </div>
                <div class="fields">
                    <div class="twelve wide field">
                        <label>Documento de identidad</label>
                        <h:inputText id="txfCiCli" pt:type="number" pt:placeholder="1222333"  value="#{detalleClienteManBean.ciCli}" />
                    </div>
                    <div class="four wide field">
                        <label>DV RUC</label>
                        <h:inputText id="txfDvrucCi" pt:type="number" pt:placeholder="9" value="#{detalleClienteManBean.dvrucCli}" />
                    </div>
                </div>
                <div class="fields">
                    <div class="six wide field">
                        <label>Teléfono</label>
                        <h:inputText id="txfTelefonoCli" pt:placeholder="09xxyyyzzzz" value="#{detalleClienteManBean.telefonoCli}"/>
                    </div>
                    <div id="fieldBarrioCliente" class="ten wide required field">
                        <label>Barrio principal</label>
                        <div id="cmbBarrioCli" class="ui fluid search selection dropdown">
                            <input jsf:id="in-idbarriocli" jsf:value="#{detalleClienteManBean.idBarrioFacturacionCli}" type="hidden"/>
                            <i class="dropdown icon" />
                            <div class="default text">Ej: Centro</div>
                            <div class="menu">
                                <ui:repeat value="#{barriosManBean.lstBarriosOrdenados}" var="barrio" varStatus="barrioStatus">
                                    <div class="item" data-value="#{barrio.idbarrio}">#{barrio.nombre}</div>
                                </ui:repeat>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="field">
                    <label>Dirección principal</label>
                    <div id="searchDireccionCli" class="ui search">
                        <h:inputText id="in-barriocli" class="prompt" value="#{detalleClienteManBean.direccionFacturacionCli}" pt:placeholder="Ej: Tuyuti"/>
                        <div class="resutls"></div>
                    </div>
                </div>
                <div id="fieldCobradorCli" class="required field">
                        <label>Cobrador</label>
                        <div id="cmbCobradorCli" class="ui fluid search selection dropdown">
                            <h:inputHidden id="in-idcobrador-cli" value="#{detalleClienteManBean.idCobradorCli}"/>
                            <i class="dropdown icon" />
                            <div class="default text">Ej: Administración</div>
                            <div class="menu">
                                <ui:repeat value="#{detalleClienteManBean.lstCobradores}" var="cobracli">
                                    <div class="item" data-value="#{cobracli.idfuncionario}">#{cobracli.nombres} #{cobracli.apellidos}</div>
                                </ui:repeat>
                            </div>
                        </div>
                    </div>

                <h:commandLink id="bntGuardarCli" class="ui right labeled blue icon button" value="Guardar" onclick="return validarCli()" action="#{detalleClienteManBean.guardarCliente()}">
                    <i class="save icon" />
                    <f:ajax execute="@form" render="cabeceraMsgCli cuerpoMsgCli tipoMsgCli tituloDetalleCliente" onevent="function(data){ajaxGuardarCli(data)}" />
                </h:commandLink>

            </h:form>
        </div>
    </div>
    <h:form prependId="false">
        <div id="msgDetalleCli" class="ui hidden warning message">
            <h:inputHidden id="tipoMsgCli" value="#{detalleClienteManBean.tipoMsg}" />
            <i class="close icon"></i>
            <div class="header">
                <h:outputText id="cabeceraMsgCli" value="#{detalleClienteManBean.cabeceraMsgCli}" />
            </div>
            <h:outputText id="cuerpoMsgCli" value="#{detalleClienteManBean.cuerpoMsgCli}" />
        </div>
    </h:form>
    <h:outputScript target="body" library="js" name="detallecliente/formcliente.js" />
</ui:composition>